require "stow/version"
require "stow/storable"

module Stow
  @engines = { local: 'Stow::Local' }
  
  class << self
    attr_reader :engines
  end
  
  def self.new(engine, options = {})
    name = engines[engine]
    raise ArgumentError, "Unknown engine '#{engine}'" unless name
    require "stow/#{engine}" if name.start_with?('Stow::')
    klass = name.split('::').inject(Object) do |memo, name|
      memo.const_get(name)
    end
    klass.new(options)
  end
  
  class NotFoundError < StandardError
  end
end
